/*
 * Copyright (c) 2024 ShinGeTsu Meter.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */
#pragma once

#define I2C0_SPEED_kHz 360     // LCDは最大400kHz
#define I2C1_SPEED_kHz 1350    // 1500kHzぐらいが限界値

// I2C0 -> LCD
#define I2C0_SDA_PIN 12
#define I2C0_SCL_PIN 13

// I2C1 -> ADC,DAC
#define I2C1_SDA_PIN 26
#define I2C1_SCL_PIN 27

// I2Cアドレス
#define ADDR_MCP4726 0x60
#define ADDR_LCD     0x3e
#define ADDR_MCP3424 104

// DAC
#define DAC_MAX_VALUE 4095
#define DAC_MIN_VALUE 0
#define DAC_WAIT_US   16    // MCP4726の設定時間:6μs + 10μs

// ADC
// #define ADC1_DIV 3.0    // ADC1の分圧比
// #define ADC2_DIV 3.0    // ADC2の分圧比
// #define ADC3_DIV 3.0    // ADC3の分圧比
#define ADC1_DIV 1.0    // ADC1の分圧比
#define ADC2_DIV 1.0    // ADC2の分圧比
#define ADC3_DIV 1.0    // ADC3の分圧比
#define ADC4_DIV 3.0    // ADC4の分圧比

void    initI2C();
double  readConstV(bool highReso);
double  readDacV(bool highReso);
double  readPcV(bool highReso);
double  readOutputV(bool highReso);
int16_t setDacValue(int16_t value);
void    lcdPrint(uint8_t row, char *mess);
void    lcdClear();
